% Universidade de São Paulo (USP)
% Instituto de Ciências Matemáticas e de Computação (ICMC)
% SCC0251 - Processamento de Imagens - 2013/1
% Prof. Dr. Mario Gazziro
% Monitor PAE: Vinicius Ruela Pereira Borges
%
% AULA 3: Segmentação de Imagens
% CÓDIGO: Filtros de detecção de bordas baseados em derivadas de 2a ordem
% =========================================================

function bordas(img,tipo)

    % Converte pra double
    I = double(img);
    
    switch(tipo)
        case 1 %Prewitt

            wx =[-1,-1,-1;0,0,0;1,1,1];
            wy =[-1,0,1;-1,0,1;-1,0,1];
            
        case 2 %Sobel
            
            wx =[-1,-2,-1;0,0,0;1,2,1];
            wy =[-1,0,1;-2,0,2;-1,0,1];
            
    end
    
    %Obtem gx
    gx = imfilter(I,wx);
    
    %Obtem gy
    gy = imfilter(I,wy);
    
    %Magnitude
    M = abs(gx + gy);
    
    In = normalize(M);
    figure,imshow(img);
    title('Imagem original');
    figure,imshow(gx);
    title('gx');
    figure,imshow(gy);
    title('gy');
    figure,imshow(M);
    title('Magnitude');
    figure,imshow(In);
    title('Normalizada');
    figure,imshow(In > 0.5);
    title('Threshold');
    pause;
    
    close all;
    
end

function n = normalize(u)

    maior = max(max(u));
    menor = min(min(u));
    n = (u-menor)/(maior-menor);

end