% Universidade de São Paulo (USP)
% Instituto de Ciências Matemáticas e de Computação (ICMC)
% SCC0251 - Processamento de Imagens - 2013/1
% Prof. Dr. Mario Gazziro
% Monitor PAE: Vinicius Ruela Pereira Borges
%
% AULA 3: Segmentação de Imagens
% CÓDIGO: Correlação entre uma imagem "img" e um filtro "mask"
% =========================================================

function out = imfilter(img,mask)
    
    [m,n] = size(mask);

    inx = (n-1)/2;
    iny = (m-1)/2;
    
    [altura,largura,canais]=size(img);
    
    I = padarray(img,[iny,inx],'replicate');
    
    con = zeros(altura+iny,largura+inx);
    
    for i = iny+1:altura+iny
        
        for j = inx+1:largura+inx

            soma = 0;
            for s = -iny:iny
                for t = -inx:inx
                    soma = soma + I(i+s,j+t)*mask(s+iny+1,t+inx+1);
                end
            end
            con(i,j) = soma;
        end
    end
    
    out = con(iny+1:altura+iny,inx+1:largura+inx);
end