% Universidade de São Paulo (USP)
% Instituto de Ciências Matemáticas e de Computação (ICMC)
% SCC0251 - Processamento de Imagens - 2013/1
% Prof. Dr. Mario Gazziro
% Monitor PAE: Vinicius Ruela Pereira Borges
%
% AULA 3: Segmentação de Imagens
% CÓDIGO: Filtros de detecção de linhas ou pontos baseados em derivadas de 1a e 2a ordem, respectivamente
% =========================================================

function linhas(img,tipo)

    % Converte pra double
    I = double(img);
    
    switch(tipo)
        case 1 %Laplaciano: isotropico
            
            w=[1,1,1;1,-8,1;1,1,1];
            
            Ic = imfilter(I,w);
            
            In = normalize(Ic);
            
	    figure,imshow(img);
            title('Imagem original');
            figure,imshow(Ic);
            title('Valores nao-zero');
            figure,imshow(In > 0.584);
            title('Positiva');
            figure,imshow(In);
            title('Normalizada');
            
        case 2 %Deteccao de linhas: direcao dependente
            
            w=[2,-1,-1;-1,2,-1;-1,-1,2]; %diagonal 45o
                        
            Ic = imfilter(I,w);
            In = normalize(Ic);
            figure,imshow(img);
            title('Imagem original');
            figure,imshow(Ic);
            title('Valores nao-zero');
            figure,imshow(In > 0.3);
            title('Positiva');
            figure,imshow(In);
            title('Normalizada');

	case 3 %Deteccao de linhas: direcao dependente
            
            w=[-1,-1,2;-1,2,-1;2,-1,-1]; %diagonal -45o
            
            Ic = imfilter(I,w);
            In = normalize(Ic);
            figure,imshow(img);
            title('Imagem original');
            figure,imshow(Ic);
            title('Valores nao-zero');
            figure,imshow(In > 0.3);
            title('Positiva');
            figure,imshow(In);
            title('Normalizada');

	case 4 %Deteccao de linhas: direcao dependente
            
            w=[-1,2,-1;-1,2,-1;-1,2,-1]; %vertical
            
            Ic = imfilter(I,w);
            In = normalize(Ic);
            figure,imshow(img);
            title('Imagem original');
            figure,imshow(Ic);
            title('Valores nao-zero');
            figure,imshow(In > 0.3);
            title('Positiva');
            figure,imshow(In);
            title('Normalizada');


	case 5 %Deteccao de linhas: direcao dependente
             
            w=[-1,-1,-1;2,2,2;-1,-1,-1]; %horizontal
            
            Ic = imfilter(I,w);
            In = normalize(Ic);
            figure,imshow(img);
            title('Imagem original');
            figure,imshow(Ic);
            title('Valores nao-zero');
            figure,imshow(In > 0.3);
            title('Positiva');
            figure,imshow(In);
            title('Normalizada');
    end
    
    pause;
    
    close all;
    
end

function n = normalize(u);

    maior = max(max(u));
    menor = min(min(u));
    n = (u-menor)/(maior-menor);

end